Foxit PDF SDK

Public Types | Public Member Functions | List of all members
foxit::pdf::ReflowPage Class Reference
Inheritance diagram for foxit::pdf::ReflowPage:

## Public Types
enum | Flags { e_Normal = 0x0, e_WithImage = 0x1, e_NoTruncate = 0x2 }
| Enumeration for parsing flags used for a reflow page. More...

## Public Member Functions
| ReflowPage (const PDFPage &page)
| Constructor, from a parsed PDF page. More...
| ReflowPage (const ReflowPage &other)
| Constructor, with another reflow page object. More...
| ~ReflowPage ()
| Destructor.
float | GetContentHeight () const
| Get content height after current reflow page object has been parsed. More...
float | GetContentWidth () const
| Get content width after current reflow page object has been parsed. More...
Matrix | GetDisplayMatrix (float offset_x, float offset_y, int width, int height, common::Rotation rotate) const
| Get the display matrix, according to the offset of top side between current reflow page and screen. More...
String | GetFocusData (const Matrix &matrix, const PointF &point) const
| Get focus data corresponding to a given position in device coordinate system. More...
PointF | GetFocusPosition (const Matrix &matrix, const char *focus_data) const
| Get the position in device coordinate system corresponding to a given focus data. More...
bool | IsEmpty () const
| Check whether current object is empty or not. More...
bool | IsParsed () const
| Check if current reflow page has been parsed or not. More...
bool | operator!= (const ReflowPage &other) const
| Not equal operator. More...
ReflowPage & | operator= (const ReflowPage &other)
| Assign operator. More...
bool | operator== (const ReflowPage &other) const
| Equal operator. More...
void | SetImageScale (float image_scale)
| Set image scale. This can be called before calling function ReflowPage::StartParse. More...
void | SetLineSpace (float line_space)
| Set line space. This can be called before calling function ReflowPage::StartParse. More...
void | SetParseFlags (uint32 flags)
| Set the parsing flag. This can be called before calling function ReflowPage::StartParse. More...
void | SetScreenMargin (int left, int top, int right, int bottom)
| Set margin. This can be called before calling function ReflowPage::StartParse. More...
void | SetScreenSize (float width, float height)
| Set screen size. This should be called before calling functions ReflowPage::StartParse and ReflowPage::SetLineSpace. More...
void | SetTopSpace (float top_space)
| Set the top space. This can be called before calling function ReflowPage::StartParse. More...
void | SetZoom (int zoom)
| Set zoom factor. This can be called before calling function ReflowPage::StartParse. More...
common::Progressive | StartParse (common::PauseCallback *pause=0)
| Start to parse current reflow page. More...
Public Member Functions inherited from foxit::Base
FS_HANDLE | Handle () const
| Get the handle of current object. More...

## Detailed Description

In order to display page contents in a small screen device, Foxit PDF SDK introduces the concept of "reflow page". In the reflow page, original PDF page contents will be laid out to fit the specified screen size.
For a PDF page, user may wants to keep focusing on a location in the reflow page when user switches between this PDF page and its related reflow page, or switch among these related reflow pages which are in different size. In order to track the focus location, Foxit PDF SDK uses "focus data" to represent the focus location. Focus data is similar to bookmark or destination in PDF, but it is simpler. User can store the focus data (or save the data to file) so that user can retrieve the focus location again by the focus data later, even if the size of reflow page is changed.
A reflow page object should be constructed from a parsed PDF page. This class offers functions to:

- Start to parse a reflow page by functions ReflowPage::StartParse. Before parsing a reflow page, use should use function ReflowPage::SetScreenSize to specify the screen size for the reflow page. User can also use following functions to specify other factors which will affect on the parsing result for the reflow page: ReflowPage::SetZoom, ReflowPage::SetParseFlags, ReflowPage::SetLineSpace, ReflowPage::SetImageScale, ReflowPage::SetTopSpace. If these function are not called before parsing a reflow page, default values will be used. Please refer to comment of these functions for more details.
- Get the actual content size and matrix of a parsed reflow page, by functions ReflowPage::GetContentWidth, ReflowPage::GetContentHeight,ReflowPage::GetDisplayMatrix.
- Get the focus data for a specified position in reflow page, by function ReflowPage::GetFocusData, or retrieve the position by a focus data, by function ReflowPage::GetFocusPosition.

To render the reflow page, please use function common::Renderer::StartRenderReflowPage.

See also
  PDFPage
  common::Renderer

## Member Enumeration Documentation

## ◆ Flags

enum foxit::pdf::ReflowPage::Flags

Enumeration for parsing flags used for a reflow page.

Values of this enumeration can be used alone or in combination.

Enumerator
e_Normal | Parsing flag for normal mode, without image.
e_WithImage | Parsing flag for image mode.
e_NoTruncate | Parsing flag to decide whether to allow to truncate the first/last image or line of text within the specified screen size or not. The height of final parsed reflow page may be larger than the actual screen height. In this case, the content of a reflow page would be shown in more than one screen in application. Application may use following modes to show such reflow page: Show only part of content of the reflow page in the screen in one time. When user clicks or taps, show the previous or next part of content. This is like to turn to a page in a real book. Here, call this mode as "single screen mode". Show the reflow page continuously – that means user can scroll the screen to see any part of content in this reflow page. Here, call this mode as "scroll screen mode". If use "single screen mode" to show a reflow page, a truncate problem may occurs: the first line of text or image just shows the bottom half in the top of the screen, or the last line of text of image just shows the top half in the bottom of the screen. This flag can be set to avoid such problem. If use "scroll screen mode", no need to use this flag.

## Constructor & Destructor Documentation

## ◆ ReflowPage() [1/2]

foxit::pdf::ReflowPage::ReflowPage | ( | const PDFPage & | page | ) |
| explicit

Constructor, from a parsed PDF page.

Parameters

  [in] | page | A valid PDF page object which has been parsed.

## ◆ ReflowPage() [2/2]

foxit::pdf::ReflowPage::ReflowPage | ( | const ReflowPage & | other | ) |

Constructor, with another reflow page object.

Parameters

  [in] | other | Another reflow page object.

## Member Function Documentation

## ◆ GetContentHeight()

float foxit::pdf::ReflowPage::GetContentHeight | ( |  | ) | const

Get content height after current reflow page object has been parsed.

Returns
  Content height.

## ◆ GetContentWidth()

float foxit::pdf::ReflowPage::GetContentWidth | ( |  | ) | const

Get content width after current reflow page object has been parsed.

Returns
  Content width.

## ◆ GetDisplayMatrix()

Matrix foxit::pdf::ReflowPage::GetDisplayMatrix | ( | float | offset_x,
|  | float | offset_y,
|  | int | width,
|  | int | height,
|  | common::Rotation | rotate
| ) |  | const

Get the display matrix, according to the offset of top side between current reflow page and screen.

This function can only be used when reflow page has been parsed.

Parameters

  [in] | offset_x | Offset value, which means the offset from top side of current reflow page to the top side of screen.
  [in] | offset_y | Offset value, which means the offset from left side of current reflow page to the left side of screen.
  [in] | width | Width of the transformation area in screen, commonly in pixels.
  [in] | height | Height of the transformation area in screen, commonly in pixels.
  [in] | rotate | Rotation value. Please refer to values starting from common::e_Rotation0 and this should be one of these values.

Returns
  The display matrix.

## ◆ GetFocusData()

String foxit::pdf::ReflowPage::GetFocusData | ( | const Matrix & | matrix,
|  | const PointF & | point
| ) |  | const

Get focus data corresponding to a given position in device coordinate system.

This function can only be used when reflow page has been parsed.
Focus data, similar to bookmark or destination in PDF, is used to locate the position of a specified content in reflow page. For a PDF page, position of a specified content is fixed and will not be changed even if the size of related reflow page is changed. So focus data can be used to locate the same content from a PDF page in its related reflow pages with different sizes but same reflow content.
Usually, user can call function ReflowPage::GetFocusData to get focus data for a specified location, and store the focus data. When the reflow page's size is changed, user can use the stored focus data in function ReflowPage::GetFocusPosition to get the new position and then still focus on or near the same content.

Parameters

  [in] | matrix | A matrix returned by function ReflowPage::GetDisplayMatrix.
  [in] | point | The point of a specified position, in device coordinate system.

Returns
  The focus data.

## ◆ GetFocusPosition()

PointF foxit::pdf::ReflowPage::GetFocusPosition | ( | const Matrix & | matrix,
|  | const char * | focus_data
| ) |  | const

Get the position in device coordinate system corresponding to a given focus data.

This function can only be used when reflow page has been parsed.
Focus data, similar to bookmark or destination in PDF, is used to locate the position of a specified content in reflow page. For a PDF page, position of a specified content is fixed and will not be changed even if the size of related reflow page is changed. So focus data can be used to locate the same content from a PDF page in its related reflow pages with different sizes but same reflow content.
Usually, user can call function ReflowPage::GetFocusData to get focus data for a specified location, and store the focus data. When the reflow page's size is changed, user can use the stored focus data in function ReflowPage::GetFocusPosition to get the new position and then still focus on or near the same content.

Parameters

  [in] | matrix | A matrix returned by function ReflowPage::GetDisplayMatrix.
  [in] | focus_data | Focus data used to get its corresponding position in device coordinate system, with specified matrix. This is retrieved by previous calling of function ReflowPage::GetFocusData.

Returns
  The position in device coordinate system.

## ◆ IsEmpty()

bool foxit::pdf::ReflowPage::IsEmpty | ( |  | ) | const

Check whether current object is empty or not.

When the current object is empty, that means current object is useless.

Returns
  true means current object is empty, while false means not.

## ◆ IsParsed()

bool foxit::pdf::ReflowPage::IsParsed | ( |  | ) | const

Check if current reflow page has been parsed or not.

Returns
  true means current reflow page has been parsed, while false means current page has not been parsed yet.

## ◆ operator!=()

bool foxit::pdf::ReflowPage::operator!= | ( | const ReflowPage & | other | ) | const

Not equal operator.

Parameters

  [in] | other | Another reflow page object. This function will check if current object is not equal to this one.

Returns
  true means not equal, while false means equal.

## ◆ operator=()

ReflowPage& foxit::pdf::ReflowPage::operator= | ( | const ReflowPage & | other | ) |

Assign operator.

Parameters

  [in] | other | Another reflow page object, whose value would be assigned to current object.

Returns
  Reference to current object itself.

## ◆ operator==()

bool foxit::pdf::ReflowPage::operator== | ( | const ReflowPage & | other | ) | const

Equal operator.

Parameters

  [in] | other | Another reflow page object. This function will check if current object is equal to this one.

Returns
  true means equal, while false means not equal.

## ◆ SetImageScale()

void foxit::pdf::ReflowPage::SetImageScale | ( | float | image_scale | ) |

Set image scale. This can be called before calling function ReflowPage::StartParse.

Parameters

  [in] | image_scale | The image scale. This value should be positive number. If no image scale is set, value 1.0f will be used by default.

Returns
  None.

## ◆ SetLineSpace()

void foxit::pdf::ReflowPage::SetLineSpace | ( | float | line_space | ) |

Set line space. This can be called before calling function ReflowPage::StartParse.

Parameters

  [in] | line_space | The line space. This value should between -25 to (screen height/2), screen height set by the function ReflowPage::SetScreenSize. If no line space is set, value 0 will be used by default.

Returns
  None.

## ◆ SetParseFlags()

void foxit::pdf::ReflowPage::SetParseFlags | ( | uint32 | flags | ) |

Set the parsing flag. This can be called before calling function ReflowPage::StartParse.

Parameters

  [in] | flags | Parsing flags. Please refer to values starting from ReflowPage::e_Normal and this should be one or a combination of these values. If no parsing flag is set, value ReflowPage::e_Normal will be used by default.

Returns
  None.

## ◆ SetScreenMargin()

void foxit::pdf::ReflowPage::SetScreenMargin | ( | int | left,
|  | int | top,
|  | int | right,
|  | int | bottom
| ) |  |

Set margin. This can be called before calling function ReflowPage::StartParse.

If no margin has ever been set to current reflow page, Foxit PDF SDK will use value (0, 0, 0, 0) as default margin.
If new margin is set, the new margin will take effect until current reflow page has been re-parsed and rendered again.

Parameters

  [in] | left | The left margin. This value should between 0 and (screen width / 3), screen width set by the function ReflowPage::SetScreenSize.
  [in] | top | The top margin. This value should between 0 and (screen height/ 3), screen height set by the function ReflowPage::SetScreenSize.
  [in] | right | The right margin. This value should between 0 and (screen width / 3), screen width set by the function ReflowPage::SetScreenSize.
  [in] | bottom | The bottom margin. This value should between 0 and (screen height / 3), screen height set by the function ReflowPage::SetScreenSize.

Returns
  None.

## ◆ SetScreenSize()

void foxit::pdf::ReflowPage::SetScreenSize | ( | float | width,
|  | float | height
| ) |  |

Set screen size. This should be called before calling functions ReflowPage::StartParse and ReflowPage::SetLineSpace.

Before parsing a reflow page and setting line space, user should call this function to set the screen size for parsing the reflow page.

Parameters

  [in] | width | The screen width.
  [in] | height | The screen height.

Returns
  None.

## ◆ SetTopSpace()

void foxit::pdf::ReflowPage::SetTopSpace | ( | float | top_space | ) |

Set the top space. This can be called before calling function ReflowPage::StartParse.

This function is used to set the distance between the page's top and the screen's top. The distance will take effect when parsing a reflow page.

Parameters

  [in] | top_space | The top space. This value should between 0 and height. If no top space is set, value 0 will be used by default.

Returns
  None.

## ◆ SetZoom()

void foxit::pdf::ReflowPage::SetZoom | ( | int | zoom | ) |

Set zoom factor. This can be called before calling function ReflowPage::StartParse.

If no zoom factor has ever been set to current reflow page, Foxit PDF SDK will use value 100 as default zoom factor, which means 100%.
If new zoom factor is set, the new zoom factor will take effect until current reflow page has been re-parsed and rendered again.

Parameters

  [in] | zoom | Zoom factor. The value represents the percent value, for example, 100 means 100%. This value should between 25 and 1000. If no zoom factor is set, value 100 will be used by default.

Returns
  None.

## ◆ StartParse()

common::Progressive foxit::pdf::ReflowPage::StartParse | ( | common::PauseCallback * | pause = `0` | ) |

Start to parse current reflow page.

It may take a long time to parsing a reflow page, so Foxit PDF SDK uses a progressive process to do this. All the resources about reflow page will be loaded after the reflow page is parsed.
This function should be called before any getting function of current reflow page object can be used. Currently this function can not be supported if there are widget annotations in current page.

Parameters

  [in] | pause | Pause callback object which decides if the parsing process needs to be paused. This can be NULL which means not to pause during the parsing process. If this is not NULL, it should be a valid pause object implemented by user. Default value: NULL.

Returns
  A progressive object. Please check the rate of current progress by function common::Progressive::GetRateOfProgress. If the rate is not 100 yet, call function common::Progressive::Continue to continue the progress until the progress is finished.